package com.tigrek.iuea.ai;
import java.util.Random;

//Individual class
public class Chromosome {
	int index=-1;// in population will be used for cross over
	double fitness = 0.0;
	double probability=0.0;
	int fobj=0;
	int geneLength = 4;
	int[] genes = new int[geneLength];
	Random rn = new Random();
	int oldplace=-1;
	public Chromosome(int i) {
		this();
		index=i;
	}
	public Chromosome() {
		/* To speed up the computation, we can restrict that the values of variables a, b, c, and d are integers 
        between 0 and 30.
		 */
		//Set genes randomly for each individual
		for (int i = 0; i < genes.length; i++) {
			genes[i] = rn.nextInt(GA.GENEVALUE)+1;
		}
		fitness = 0;
	}
	public Chromosome(int f,int t,int [] g) {
		shiftIndex(f,t);
		setIndex(t);
		for(int j=0;j<geneLength;j++)
		{
			genes[j]=g[j];
		}
	}
	public void setIndex(int k)
	{
		this.index=k; // place in the array
	}
	public void shiftIndex(int old,int newind)
	{
		this.oldplace=old;
		this.index=newind; // place in the array
	}
	public int getIndex()
	{
		return index;
	}
	public void out()
	{
		System.out.print(this.oldplace+"/"+this.index+"/"+"#[");
		for (int i = 0; i < genes.length; i++) {

			System.out.print(genes[i]);
			if(i==genes.length-1)
			{
				System.out.print("]\t");
			}else
			{
				System.out.print(",");
			}
		}
	}
	//Calculate fitness
	public void calcFitness() {
		int [] coeff= {1,2,3,4}; // a+2b+3c+4d=30
		int rhs=30;
		fitness = 0;
		int eq=0;
		for (int i = 0; i < genes.length; i++) {
			eq=eq+genes[i]*coeff[i];
		}
		fobj=Math.abs(eq-rhs);
		fitness=1.0/(1.0+fobj);
	}
	public void calcProb(double tot)
	{
		probability=fitness/tot;
	}
	public void mutate()
	{
		if(!GA.FINAL)
		{
			System.out.print(" Before: ");
			out();
		}
		int m=rn.nextInt(geneLength);
		genes[m] = rn.nextInt(GA.GENEVALUE)+1;
		if(!GA.FINAL)
		{
			System.out.print(" After: ");
			out();
		}
		if(!GA.FINAL)
			System.out.println("Mutated gene#"+m);
	}
	public Chromosome clone(int f,int t)
	{
		Chromosome nc=new Chromosome(f,t,genes);
		return nc;
	}
}
